using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace GR
{
    public partial class frmSetup : Form
    {
        public event LoginHandler LoginCalled;
        public EventArgs e = null;
        public delegate void LoginHandler(System.Windows.Forms.Button btn, EventArgs e);

        public bool bAutoLogin = false;
        public frmSetup()
        {
            InitializeComponent();
            this.FormClosing += new FormClosingEventHandler(frmSetup_FormClosing);
        }

        void frmSetup_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
        public void AutoLogin()
        {
            bAutoLogin = Convert.ToBoolean(System.Configuration.ConfigurationSettings.AppSettings["autologin"]);
            this.LoginCalled += new LoginHandler(frmSetup_LoginCalled);
            ckSettings.Checked = bAutoLogin;
            if (bAutoLogin)
            {
                this.txtUser.Text = System.Configuration.ConfigurationSettings.AppSettings["user"];
                this.txtPassword.Text = System.Configuration.ConfigurationSettings.AppSettings["password"];
                if (LoginCalled != null)
                    LoginCalled(btnLogin, System.EventArgs.Empty);
            }
        }

        void frmSetup_LoginCalled(Button btn, EventArgs e)
        {
           
        }
        private void frmSetup_Load(object sender, EventArgs e)
        {
           
        }

        public void btnLogin_Click(object sender, EventArgs e)
        {
            LoginCalled(btnLogin, System.EventArgs.Empty);
        }

        private void ckSettings_CheckedChanged(object sender, EventArgs e)
        {
            if (ckSettings.Checked == bAutoLogin)
                return;
            bAutoLogin = ckSettings.Checked;
            replaceConfigSettings("autologin",ckSettings.Checked.ToString());
            if (ckSettings.Checked)
            {
               replaceConfigSettings("user",txtUser.Text);
               replaceConfigSettings("password", txtPassword.Text);
            }
        }
        static public void replaceConfigSettings(string key, string val)
        {
            XmlDocument xDoc = new XmlDocument();
            string sFileName = Application.StartupPath + @"\GRArb.exe.config";
            try
            {
                // load the configuration file
                xDoc.Load(sFileName);
                // find the node of interest containing the key using XPATH
                XmlNode theNode = xDoc.SelectSingleNode(@"/configuration/appSettings/add[@key = '" + key + "\']");
                // Set the new value for the node
                if (theNode != null)
                    theNode.Attributes["value"].Value = val;
                // lop off file prefix of the filename if it exists
                if (sFileName.StartsWith("file:///"))
                    sFileName = sFileName.Remove(0, 8);
                // save the new configuration settings
                xDoc.Save(sFileName);
                xDoc = null;
            }
            catch (Exception ex)
            {
             //   System.Windows.Forms.MessageBox.Show("replaceConfigSettings()" + ex.Message);
                xDoc = null;
            }
        }
    }
}